TEMPLATE = app

QT += qml quick

DEFINES -= UNICODE

# Generate pdb files also for the release version,
QMAKE_CXXFLAGS += -Zi
QMAKE_LFLAGS += /INCREMENTAL:NO /Debug

SOURCES += main.cpp \
    src/PortableTimer.cpp \
    src/SystemTime.cpp \
    src/sync/data.c \
    src/sync/device.c \
    src/sync/track.c \
    src/Rocket.cpp \
    src/RocketQML.cpp \
    src/IFileAutoLoader.cpp \
    src/Shader.cpp \
    src/datafile.cpp \
    src/assimp/color4.inl \
    src/assimp/material.inl \
    src/assimp/matrix3x3.inl \
    src/assimp/matrix4x4.inl \
    src/assimp/quaternion.inl \
    src/assimp/vector2.inl \
    src/assimp/vector3.inl \
    src/SceneAI.cpp \
    src/Music.cpp \
    src/MeshQML.cpp \
    src/IRenderItem.cpp \
    src/Camera.cpp \
    src/GLTexture.cpp \
    src/GLTexturePool.cpp \
    src/Pool.cpp \
    src/PoolObject.cpp \
    src/CameraQML.cpp \
    src/PosQML.cpp \
    src/RotQML.cpp \
    src/ScaQML.cpp \
    src/DemoQML.cpp \
    src/SceneQML.cpp \
    src/IEffect.cpp \
    src/RenderTargetQML.cpp \
    src/ShaderParamQML.cpp \
    src/ImageLayerQML.cpp \
    src/dataobject.cpp \
    src/MeshPool.cpp \
    src/ShaderPool.cpp \
    src/ShadeQML.cpp \
    src/TextureQML.cpp \
    src/DrawVBQML.cpp \
    src/GLStateStacks.cpp \
    src/IDrawEffect.cpp \
    src/ClearQML.cpp \
    src/RenderTargetLayerQML.cpp \
    src/TransformFeedback.cpp \
    src/TransformFeedbackPool.cpp \
    src/GroupQML.cpp \
    src/DOActiveSkenes.cpp \
    src/DemoRootQML.cpp \
    src/SavePointQML.cpp \
    src/ShaderAtomiCounterQML.cpp \
    src/ShaderBufferQML.cpp \
    src/GLShaderBuffer.cpp \
    src/GLShaderBufferPool.cpp \
    src/GLShaderAtomicCounter.cpp \
    src/GLShaderAtomicCounterPool.cpp \
    src/ParamGroupQML.cpp

# RESOURCES += qml.qrc

# Additional import path used to resolve QML modules in Qt Creator's code model
QML_IMPORT_PATH = ./plugins


HEADERS += \
    src/PortableTimer.h \
    src/SystemTime.h \
    src/sync/base.h \
    src/sync/data.h \
    src/sync/device.h \
    src/sync/sync.h \
    src/sync/track.h \
    src/Singleton.h \
    src/Rocket.h \
    src/RocketQML.h \
    src/IFileAutoLoader.h \
    src/Shader.h \
    src/datafile.h \
    src/assimp/Compiler/poppack1.h \
    src/assimp/Compiler/pushpack1.h \
    src/assimp/ai_assert.h \
    src/assimp/anim.h \
    src/assimp/camera.h \
    src/assimp/cexport.h \
    src/assimp/cfileio.h \
    src/assimp/cimport.h \
    src/assimp/color4.h \
    src/assimp/config.h \
    src/assimp/DefaultLogger.hpp \
    src/assimp/defs.h \
    src/assimp/Exporter.hpp \
    src/assimp/Importer.hpp \
    src/assimp/importerdesc.h \
    src/assimp/IOStream.hpp \
    src/assimp/IOSystem.hpp \
    src/assimp/light.h \
    src/assimp/Logger.hpp \
    src/assimp/LogStream.hpp \
    src/assimp/material.h \
    src/assimp/matrix3x3.h \
    src/assimp/matrix4x4.h \
    src/assimp/mesh.h \
    src/assimp/NullLogger.hpp \
    src/assimp/postprocess.h \
    src/assimp/ProgressHandler.hpp \
    src/assimp/quaternion.h \
    src/assimp/scene.h \
    src/assimp/texture.h \
    src/assimp/types.h \
    src/assimp/vector2.h \
    src/assimp/vector3.h \
    src/assimp/version.h \
    src/GL/glew.h \
    src/GL/glxew.h \
    src/GL/wglew.h \
    src/SceneAI.h \
    src/Music.h \
    src/MeshQML.h \
    src/IRenderItem.h \
    src/Camera.h \
    src/GLTexture.h \
    src/GLTexturePool.h \
    src/Pool.h \
    src/PoolObject.h \
    src/CameraQML.h \
    src/PosQML.h \
    src/RotQML.h \
    src/ScaQML.h \
    src/DemoQML.h \
    src/IEffect.h \
    src/SceneQML.h \
    src/RenderTargetQML.h \
    src/ShaderParamQML.h \
    src/ImageLayerQML.h \
    src/dataobject.h \
    src/MeshPool.h \
    src/ShaderPool.h \
    src/ShadeQML.h \
    src/TextureQML.h \
    src/DrawVBQML.h \
    src/GLStateStacks.h \
    src/IDrawEffect.h \
    src/ClearQML.h \
    src/RenderTargetLayerQML.h \
    src/TransformFeedback.h \
    src/TransformFeedbackPool.h \
    src/GroupQML.h \
    src/ActiveScene.h \
    src/DOActiveSkenes.h \
    src/DemoRootQML.h \
    src/SavePointQML.h \
    src/SavePoint.h \
    src/shadervarying.h \
    src/ShaderBufferQML.h \
    src/GLShaderBuffer.h \
    src/GLShaderBufferPool.h \
    src/ShaderAtomicCounterQML.h \
    src/GLShaderAtomicCounter.h \
    src/GLShaderAtomicCounterPool.h \
    src/ParamGroupQML.h

LIBS += \
    user32.lib \
    gdi32.lib \
    ws2_32.lib \
    winmm.lib \
    opengl32.lib \
    C:\joni\adapt\lightforce\glew32.lib \
    C:\joni\adapt\lightforce\glut32.lib \
    C:\joni\adapt\lightforce\assimp.lib \
    C:\joni\adapt\lightforce\fmodex_vc.lib

LIBPATH += \
    C:\joni\adapt\lightforce

INCLUDEPATH += \
    src \
    src/glm \
    src/assimp \
    src/fmod/inc \




# Default rules for deployment.
include(deployment.pri)

qmlfolder.source = fx
qmlfolder.target = /
DEPLOYMENTFOLDERS += qmlfolder

Deployment()
